/* astal-io-0.1.vapi generated by valac 0.56.18, do not modify. */

[CCode (gir_namespace = "AstalIO", gir_version = "0.1")]
namespace AstalIO {
	[CCode (cheader_filename = "astal-io.h")]
	[DBus (name = "io.Astal.Application")]
	public class Daemon : GLib.Application, AstalIO.Application {
		public Daemon ();
		/**
		 * Handler for an incoming request.
		 *
		 * @param request Body of the request
		 * @param conn The connection which expects the response.
		 */
		[DBus (visible = false)]
		public virtual void request (string request, GLib.SocketConnection conn);
	}
	/**
	 * `Process` provides shortcuts for [class@Gio.Subprocess] with sane defaults.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public class Process : GLib.Object {
		/** See [func@AstalIO.Process.subprocessv] */
		public Process (string[] cmd) throws GLib.Error;
		/**
		 * Execute a command synchronously.
		 * The command is parsed using [func@GLib.shell_parse_argv].
		 *
		 * @return stdout of the subprocess
		 */
		public static string exec (string cmd) throws GLib.Error;
		/**
		 * Execute a command asynchronously.
		 * The command is parsed using [func@GLib.shell_parse_argv].
		 *
		 * @return stdout of the subprocess
		 */
		public static async string exec_async (string cmd) throws GLib.Error;
		/**
		 * Execute a command asynchronously.
		 * The first element of the vector is executed with the remaining elements as the argument list.
		 *
		 * @return stdout of the subprocess
		 */
		public static async string exec_asyncv (string[] cmd) throws GLib.Error;
		/**
		 * Execute a command synchronously.
		 * The first element of the vector is executed with the remaining elements as the argument list.
		 *
		 * @return stdout of the subprocess
		 */
		public static string execv (string[] cmd) throws GLib.Error;
		/**
		 * Force quit the subprocess.
		 */
		public void kill ();
		/**
		 * Send a signal to the subprocess.
		 *
		 * @param signal_num Signal number to be sent
		 */
		public void @signal (int signal_num);
		/**
		 * Start a new subprocess with the given command
		 * which is parsed using [func@GLib.shell_parse_argv].
		 */
		public static AstalIO.Process subprocess (string cmd) throws GLib.Error;
		/**
		 * Start a new subprocess with the given command.
		 *
		 * The first element of the vector is executed with the remaining elements as the argument list.
		 */
		public static AstalIO.Process subprocessv (string[] cmd) throws GLib.Error;
		/**
		 * Write a line to the subprocess' stdin synchronously.
		 *
		 * @param in String to be written to stdin
		 */
		public void write (string @in) throws GLib.Error;
		/**
		 * Write a line to the subprocess' stdin asynchronously.
		 *
		 * @param in String to be written to stdin
		 */
		public async void write_async (string @in);
		public string[] argv { get; construct; }
		/**
		 * When the underlying subprocess exits or is terminated.
		 *
		 * @param code Exit code or signal number if terminated
		 */
		public signal void exit (int code, bool terminated);
		/**
		 * When the underlying subprocess writes to its stderr.
		 *
		 * @param err Line written to stderr
		 */
		public signal void stderr (string err);
		/**
		 * When the underlying subprocess writes to its stdout.
		 *
		 * @param out Line written to stdout
		 */
		public signal void stdout (string @out);
	}
	/**
	 * `Time` provides shortcuts for GLib timeout functions.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public class Time : GLib.Object {
		public Time ();
		/**
		 * Cancel timer and emit [signal@AstalIO.Time::cancelled]
		 */
		public void cancel ();
		/**
		 * Start a timer which will tick when there are no higher priority tasks pending.
		 *
		 * @param fn Optional callback.
		 */
		public static AstalIO.Time idle (GLib.Closure? fn);
		/**
		 * Start an idle timer with default priority.
		 */
		public Time.idle_prio (int prio = GLib.Priority.DEFAULT_IDLE, GLib.Closure? fn);
		/**
		 * Start an interval timer. Ticks immediately then every `interval` milliseconds.
		 *
		 * @param interval Tick every milliseconds.
		 * @param fn Optional callback.
		 */
		public static AstalIO.Time interval (uint interval, GLib.Closure? fn);
		/**
		 * Start an interval timer with default Priority.
		 */
		public Time.interval_prio (uint interval, int prio = GLib.Priority.DEFAULT, GLib.Closure? fn);
		/**
		 * Start a timeout timer which ticks after `timeout` milliseconds.
		 *
		 * @param timeout Tick after milliseconds.
		 * @param fn Optional callback.
		 */
		public static AstalIO.Time timeout (uint timeout, GLib.Closure? fn);
		/**
		 * Start a timeout timer with default Priority.
		 */
		public Time.timeout_prio (uint timeout, int prio = GLib.Priority.DEFAULT, GLib.Closure? fn);
		/**
		 * Emitted when the timere is cancelled.
		 */
		public signal void cancelled ();
		/**
		 * Emitted when the timer ticks.
		 */
		public signal void now ();
	}
	[CCode (cheader_filename = "astal-io.h")]
	public class Variable : AstalIO.VariableBase {
		public Variable (GLib.Value init);
		public bool is_polling ();
		public bool is_watching ();
		public AstalIO.Variable poll (uint interval, string exec, GLib.Closure? transform) throws GLib.Error;
		public AstalIO.Variable pollfn (uint interval, GLib.Closure fn) throws GLib.Error;
		public AstalIO.Variable pollv (uint interval, string[] execv, GLib.Closure? transform) throws GLib.Error;
		public void start_poll () throws GLib.Error;
		public void start_watch () throws GLib.Error;
		public void stop_poll ();
		public void stop_watch ();
		public AstalIO.Variable watch (string exec, GLib.Closure? transform) throws GLib.Error;
		public AstalIO.Variable watchv (string[] execv, GLib.Closure? transform) throws GLib.Error;
		public GLib.Value value { owned get; set; }
	}
	[CCode (cheader_filename = "astal-io.h")]
	public class VariableBase : GLib.Object {
		public VariableBase ();
		public void emit_changed ();
		public void emit_dropped ();
		public void emit_error (string err);
		public signal void changed ();
		public signal void dropped ();
		public signal void error (string err);
	}
	/**
	 * This interface is used internally in Astal3 and Astal4, not meant for public usage.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public interface Application : GLib.Object {
		public abstract void acquire_socket () throws GLib.Error;
		public abstract void inspector () throws GLib.Error;
		public abstract void quit () throws GLib.Error;
		public virtual void request (string request, GLib.SocketConnection conn) throws GLib.Error;
		public abstract void toggle_window (string window) throws GLib.Error;
		public abstract string instance_name { owned get; set construct; }
	}
	[CCode (cheader_filename = "astal-io.h")]
	public errordomain AppError {
		NAME_OCCUPIED,
		TAKEOVER_FAILED
	}
	[CCode (cheader_filename = "astal-io.h")]
	public const int MAJOR_VERSION;
	[CCode (cheader_filename = "astal-io.h")]
	public const int MICRO_VERSION;
	[CCode (cheader_filename = "astal-io.h")]
	public const int MINOR_VERSION;
	[CCode (cheader_filename = "astal-io.h")]
	public const string VERSION;
	/**
	 * Starts a [class@Gio.SocketService] and binds `XDG_RUNTIME_DIR/astal/<instance_name>.sock`.
	 * This socket is then used by the astal cli. Not meant for public usage, but for [method@AstalIO.Application.acquire_socket].
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static GLib.SocketService acquire_socket (AstalIO.Application app, out string sock) throws GLib.Error;
	/**
	 * Get a list of running Astal.Application instances.
	 * It is the equivalent of `astal --list`.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static GLib.List<string> get_instances ();
	/**
	 * Monitor a file for changes. If the path is a directory, monitor it recursively.
	 * The callback will be called passed two parameters: the path of the file
	 * that changed and an [enum@Gio.FileMonitorEvent] indicating the reason.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static GLib.FileMonitor? monitor_file (string path, GLib.Closure callback);
	/**
	 * Open the Gtk debug tool of an an Astal instances.
	 * It is the equivalent of `astal --inspector -i instance`.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static void open_inspector (string instance) throws GLib.Error;
	/**
	 * Quit an an Astal instances.
	 * It is the equivalent of `astal --quit -i instance`.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static void quit_instance (string instance) throws GLib.Error;
	/**
	 * Read the contents of a file synchronously.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static string read_file (string path);
	/**
	 * Read the contents of a file asynchronously.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static async string read_file_async (string path) throws GLib.Error;
	/**
	 * Read the socket of an Astal.Application instance.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static async string read_sock (GLib.SocketConnection conn) throws GLib.IOError;
	/**
	 * Use [func@AstalIO.send_request] instead.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	[Version (deprecated = true)]
	public static string send_message (string instance, string request) throws GLib.Error;
	/**
	 * Send a request to an Astal instances.
	 * It is the equivalent of `astal -i instance "request content"`.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static string send_request (string instance, string request) throws GLib.Error;
	/**
	 * Toggle a Window of an Astal instances.
	 * It is the equivalent of `astal -i instance --toggle window`.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static void toggle_window_by_name (string instance, string window) throws GLib.Error;
	/**
	 * Write content to a file synchronously.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static void write_file (string path, string content);
	/**
	 * Write content to a file asynchronously.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static async void write_file_async (string path, string content) throws GLib.Error;
	/**
	 * Write the socket of an Astal.Application instance.
	 */
	[CCode (cheader_filename = "astal-io.h")]
	public static async void write_sock (GLib.SocketConnection conn, string response) throws GLib.IOError;
}
